"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  EjsAPI: () => EjsAPI,
  renderString: () => import_utils.renderString
});
module.exports = __toCommonJS(src_exports);
var import_define_property = require("@swc/helpers/_/_define_property");
var import_codesmith = require("@modern-js/codesmith");
var import_utils = require("./utils");
class EjsAPI {
  async renderTemplate(templateResource, target, parameters = {}) {
    if (templateResource._type !== import_codesmith.FS_RESOURCE) {
      throw new Error("resource not match");
    }
    const resourceValue = await templateResource.value();
    if (typeof resourceValue.content !== "string") {
      throw new Error(`resource.value is not string, resourceValue=${resourceValue}`);
    }
    await this.generatorCore.output.fs(target, (0, import_utils.renderString)(resourceValue.content, parameters), {
      encoding: "utf-8"
    });
  }
  async renderTemplateDir(material, findGlob, target, options) {
    const resourceMap = await material.find(findGlob, {
      nodir: true,
      ...options
    });
    await Promise.all(
      // resourceKey is relate path. example: in `garr-master/package.json`, package.json is resourceKey
      Object.keys(resourceMap).map(async (resourceKey) => {
        this.generatorCore.logger.debug(`[renderDir] resourceKey=${resourceKey}`);
        await this.renderTemplate(material.get(resourceKey), target(resourceKey), options === null || options === void 0 ? void 0 : options.parameters);
      })
    );
  }
  constructor(generatorCore) {
    (0, import_define_property._)(this, "generatorCore", void 0);
    this.generatorCore = generatorCore;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EjsAPI,
  renderString
});
